#!/usr/bin/env python

# TODO, export, import

# Loading modules
import sys
import os
import readline
import zipfile
import StringIO
import string 
from distutils import file_util
from distutils import dir_util

# Loading GTK modules
try:
	import pygtk
	pygtk.require("2.0")
except:
	pass

try:
        import gtk
        import gtk.glade
        import gobject
except:
	print "You need pyGTk or GTKv2"
	sys.exit(1)

# Checking for convert and webdec
if sys.platform.startswith("win"):
        print "This window has to be kept open.\nPlease don't pay attentions to errors."
	if os.path.isfile(os.curdir + os.sep + "Bin" + os.sep + "imconvert.exe") == False:
		print "'convert.exe' is missing, please reinstall this program"
		sys.exit(1)
	if os.path.isfile(os.curdir + os.sep + "Bin" + os.sep + "webdec.exe") == False:
		print "'webdec.exe' is missing, please reinstall this program"
		sys.exit(1)
else:
	if os.path.isfile(os.popen("which convert", "r").read().split()[0]) == False:
		print "You need to have 'convert' in your path"
		sys.exit(1)
 	if os.path.isfile(os.popen("which webdec", "r").read().split()[0]) == False:
		print "You need to have 'webdec' in your path"
		sys.exit(1)

class websun:
	def __init__(self):
		
		# Loading main window
		self.gladefile = os.getcwd() + os.sep + "websun.glade"
		windowname = "window1"
		self.gladeui = gtk.glade.XML(self.gladefile,windowname)
		actions = {"on_button_bg_clicked": self.set_background,
			"on_window1_destroy": (gtk.mainquit),
			"on_button_add_clicked": self.add_group_dialog,
			"on_button_remove_clicked": self.remove_group_dialog,
			"on_import1_activate": self.import_pix,
			"on_quit1_activate": (gtk.mainquit),
			"on_export1_activate": self.export_pix,
			"on_about1_activate": self.about_dialog,
			"on_settings1_activate": self.setting_dialog}
		self.gladeui.signal_autoconnect(actions)

		# Some startup vars
		self.which_file = 0
		self.targets = [("text/plain", 0, 5)]
		target_list = [("text/plain", 0, 5)]
		if sys.platform.startswith("win"):
			self.conf_path = os.curdir
			self.convert = "imconvert.exe"
                        os.environ['PATH'] += ";%sBin;" % (os.getcwd() + os.sep)
                        
                else:
			self.conf_path = os.path.expanduser("~")
			self.convert = "convert"

		# Checking for config file
		if os.path.isfile(self.conf_path + os.sep + ".websun") == False:
			conf = open(self.conf_path + os.sep + ".websun", "w")
			conf.write("BACKGROUNDS_PATH=")
			conf.close()
			self.settinginfo = False
			self.setting_dialog()
			
		else:
			self.settinginfo = True
			websun_conf_f = open(self.conf_path + os.sep + ".websun", "r")
			websun_conf = websun_conf_f.readlines()
			for l in websun_conf:
				if l.startswith("BACKGROUNDS_PATH"):
					self.bgpath = l[l.find("=")+1:].strip()
			self.run_check()

	# Checking for all files and directories
	def run_check(self, *args):
		# Checking for dirs "all" and "collections"
		if os.path.isdir(self.bgpath + os.sep + "all") == False:
			dir_util.mkpath(self.bgpath + os.sep + "all")
		if os.path.isdir(self.bgpath + os.sep + "collections") == False:
			dir_util.mkpath(self.bgpath + os.sep + "collections")
		
		# Checking for all symlinks, thumbs and nfo
		self.albums = os.listdir(self.bgpath + os.sep + "collections")
		self.albums.sort()
		if not self.albums == []:
			for album in self.albums:
				a = os.listdir(self.bgpath + os.sep + "collections" + os.sep + album)
				if not "thumbs" + os.sep in a:
					dir_util.mkpath(self.bgpath + os.sep + "collections" + os.sep + album + os.sep + "thumbs")
				if not "nfo" + os.sep in a:
					dir_util.mkpath(self.bgpath + os.sep + "collections" + os.sep + album + os.sep + "nfo")
				# Checking thumbs
				thumblist = []
				for thumbs in os.listdir(self.bgpath + os.sep + "collections" + os.sep + album + os.sep + "thumbs"):
					if ".jpg" in thumbs:
						thumblist.append(thumbs)

				for files in a:
					if ".jpg" in files:
						if files not in thumblist:
                                        		s = self.bgpath + os.sep + "all" + os.sep + files
                                        		t = self.bgpath + os.sep + "collections" + os.sep + album + os.sep + "thumbs" + os.sep + files
							os.system('%s "%s" -resize 73x55 "%s"' % (self.convert, s, t))

				# Checking nfo
				nfolist = []
				for nfos in os.listdir(self.bgpath + os.sep + "collections" + os.sep + album + os.sep + "nfo"):
					if ".jpg" in thumbs:
						nfolist.append(nfos[0:len(nfos)-4])
				
				for nfo in nfolist:
					if nfo + ".jpg" not in thumblist:
                                       		os.remove(self.bgpath + os.sep + "collections" + os.sep + album + os.sep + "nfo" + os.sep + nfo + ".nfo")
			# Loading treeview
			self.path = self.bgpath + os.sep + "collections" + os.sep + album + os.sep + "thumbs"
			self.get_thumbs()
                        self.setup_treeview()
                        
			
							
		
	# Setting up the treeview for the collections
	def setup_treeview(self, *args):
		self.treeview = self.gladeui.get_widget("treeview1")
		self.treemodel=gtk.TreeStore(gobject.TYPE_STRING, gobject.TYPE_STRING)
		self.treeview.set_model(self.treemodel)
		renderertext = gtk.CellRendererText()
		column = gtk.TreeViewColumn("Collection", renderertext, text=0)
		self.treeview.append_column(column)
		self.treeview.drag_dest_set(gtk.DEST_DEFAULT_ALL, self.targets,
        				gtk.gdk.ACTION_COPY | gtk.gdk.ACTION_MOVE)
    		self.treeview.connect("drag_drop", self.on_drag_drop)
		self.treeview.connect("button-press-event", self.button_event2)

		# getting all the albums into rows 
		for m in self.albums:
			iter = self.treemodel.append(None)
			self.treemodel.set(iter, 0, m)
		
		self.treeview.show()
		self.selection = self.treeview.get_selection()
		self.selection.select_iter(iter)
		self.load_collection()
		self.selection.connect("changed", self.load_collection)
	
	def load_collection(self, *args):
		model, iter = self.selection.get_selected()
		self.select_value = self.treemodel.get_value(iter, 0)
		self.s_iter = iter
		self.path = self.bgpath + os.sep + "collections" + os.sep + self.select_value + os.sep + "thumbs" + os.sep
		imagedir = self.bgpath + os.sep + "collections" + os.sep + self.select_value + os.sep
		
		# Checking new files
		thumblist = []
		for thumbs in os.listdir(self.path):
			if ".jpg" in thumbs:
				thumblist.append(thumbs)
		
		for files in os.listdir(imagedir):
			if ".jpg" in files:
				if files not in thumblist:
                                        s = self.bgpath + os.sep + "all" + os.sep + files
                                        t = self.bgpath + os.sep + "collections" + os.sep + self.select_value + os.sep + "thumbs" + os.sep + files
                                        os.system('%s "%s" -resize 73x55 "%s"' % (self.convert, s, t))
		
		# Remove existing cells
		for a in self.button:
			a.destroy()

		# Start the function to get the new images
		self.get_thumbs()

	# Loading thumbs into table
	def get_thumbs(self):
		self.table = self.gladeui.get_widget("table1")
		self.button = []
		self.image_file = []
		no_img = 0
		thumbs = 0
		leftt = -1
		rightt = 0
		topt = 0
		bottomt = 1
		filelist = os.listdir(self.path)
		for files in filelist:
			if ".jpg" in files:
				thumbs = thumbs + 1
				self.image_file.append(files)
				image = gtk.Image()
				image.set_from_file(self.path + files)
				image.show()
				
				self.button.append(gtk.Button())
				self.button[no_img].add(image)
				self.button[no_img].drag_source_set(gtk.gdk.BUTTON1_MASK, self.targets, gtk.gdk.ACTION_COPY | gtk.gdk.ACTION_MOVE)
				self.button[no_img].connect("button-press-event", self.button_event)
				self.button[no_img].connect("clicked", self.click_wallpaper)
				
				leftt = leftt + 1
				rightt = rightt + 1
				self.table.attach(self.button[no_img], leftt, rightt, topt, bottomt)	
				self.button[no_img].show()
				no_img = no_img + 1
				if thumbs == 3:
					topt = topt + 1
					bottomt = bottomt + 1
					leftt = -1
					rightt = 0
					thumbs = 0

	# Changing Settings
	def setting_dialog(self, *args):
		windowname = "dialog_settings"
		self.dialog_settings = gtk.glade.XML(self.gladefile, windowname)
		actions = {"on_cancelbutton6_clicked": self.kill_setting_dialog,
			"on_button2_clicked": self.get_file,
			"on_okbutton6_clicked": self.write_settings}
		self.dialog_settings.signal_autoconnect(actions)
		self.which_file = 3
		if self.settinginfo == True:
                	self.dialog_settings.get_widget("entry11").set_text(self.bgpath)
	
	def write_settings(self, widget):
		if not self.dialog_settings.get_widget("entry11").get_text() == "":
			websun_conf_f = open(self.conf_path + os.sep + ".websun", "r")
			websun_conf = websun_conf_f.readlines()
			websun_newconf = []
			for l in websun_conf:
				if l.startswith("BACKGROUNDS_PATH="):
					bg = self.dialog_settings.get_widget("entry11").get_text()
					self.bgpath = bg
					self.settinginfo = True
					websun_newconf.append("BACKGROUNDS_PATH=" + bg)
					websun_newconf.append(os.linesep)
				else:
					websun_newconf.append(l)
			websun_conf_f.close()
			websun_conf_f = open(self.conf_path + os.sep + ".websun", "w")
			for a in websun_newconf:
				websun_conf_f.write(a)
			websun_conf_f.close()
			self.run_check()
			if not self.albums == []:
                                self.refresh_categories()
			self.dialog_settings.get_widget("dialog_settings").destroy()	

	def kill_setting_dialog(self, widget):
		if not self.dialog_settings.get_widget("entry11").get_text() == "":
			self.dialog_settings.get_widget("dialog_settings").destroy()

	# Function to refresh the list of categories
	def refresh_categories(self):
		self.albums = os.listdir(self.bgpath + os.sep + "collections")
		self.albums.sort()
		self.treemodel.clear()
		for m in self.albums:
			iter = self.treemodel.append(None)
			self.treemodel.set(iter, 0, m)
		

	# When a Wallpaper is clicked
	def click_wallpaper(self, widget):
		no = -1
		for a in self.button:
			no = no + 1
			if a == widget:
				break
		self.gladeui.get_widget("image1").set_from_file(self.path + self.image_file[no])
		self.selected_img = self.image_file[no]
		self.wallpaper = self.bgpath + os.sep + "all" + os.sep + self.image_file[no]
		image = gtk.Image()
		image.set_from_file(self.wallpaper)
		pixbuf = image.get_pixbuf()
		width = pixbuf.get_width()
		height = pixbuf.get_height()
		# Setting the Name
		self.gladeui.get_widget("label_name").set_text(self.image_file[no][0:len(self.image_file[no])-4])
		# Setting the Author
		info_f = open(self.bgpath + os.sep + "collections" + os.sep + self.select_value + os.sep + "nfo" + os.sep + self.image_file[no][0:len(self.image_file[no])-4] + ".nfo")
		info = info_f.readlines()
		for l in info:
			if l.startswith("CREDIT"):
				author = l[l.find(":")+1:].strip()
		self.gladeui.get_widget("label_author").set_text(author)
		# Setting the resolution
		self.gladeui.get_widget("label_res").set_text(str(width) + "x" + str(height))
		info_f.close()

	# Function to set background
	def set_background(self, *args):
		if sys.platform.startswith("win"):
                	os.system('bsetbg "%s"' % (self.wallpaper))
		else:
			kdeset = False
			f = os.popen("ps aux", "r")
			for l in f.readlines():
				field = string.split(l)
				if "gnome-session" in field[10]:
					os.system("gconftool --type=string --set /desktop/gnome/background/picture_filename " + '"' + self.wallpaper + '"')
				if "kdeinit" in field[10] and kdeset == False:
					os.system("dcop kdesktop KBackgroundIface setWallpaper " + '"' + self.wallpaper + '" ' + "6")		
					kdeset = True

	# When dragging photos to another collection
	def on_drag_drop(self, widget, dragcontext, x, y, *args):
		target_row, unk = self.treeview.get_dest_row_at_pos(x, y)
		target = self.treemodel.get_iter(target_row)
		target_name = self.treemodel.get_value(target, 0)
		no = -1
		for a in self.button:
			no = no + 1
			if a == dragcontext.get_source_widget():
				break
		if not self.select_value == target_name:
			info_f_source = open(self.bgpath + os.sep + "collections" + os.sep + self.select_value + os.sep + "nfo" + os.sep + self.image_file[no][0:len(self.image_file[no])-4] + ".nfo", "r")
			info_source = info_f_source.readlines()
			nfo_f = ""
			for l in info_source:
				if l.startswith("TITLE:"):
					nfo_f = nfo_f + l
				if l.startswith("CREDIT:"):
					nfo_f = nfo_f + l 
				if l.startswith("COLLECTION:"):
					nfo_f = nfo_f + "COLLECTION:" + target_name + "\n"
				if l.startswith("CATAGORY:"):
					nfo_f = nfo_f + "CATAGORY:" + target_name[0:target_name.find("-")-2] + "\n"
				if l.startswith("ALBUM:"):
					nfo_f = nfo_f + "ALBUM:" + target_name + "\n"
				if l.startswith("WNUM:"):
					nfo_f = nfo_f + l
				if l.startswith("FILE_SIZE:"):
					nfo_f = nfo_f + l 
				if l.startswith("FILE_TYPE:"):
					nfo_f = nfo_f + l.strip() 
			info_f_source.close()
			# Creating new file
			info_f_target = open(self.bgpath + os.sep + "collections" + os.sep + target_name + os.sep + "nfo" + os.sep + self.image_file[no][0:len(self.image_file[no])-4] + ".nfo", "w")
			# Write new file
			info_f_target.write(nfo_f)
			info_f_target.close()
			# Removing old file
			os.remove(self.bgpath + os.sep + "collections" + os.sep + self.select_value + os.sep + "nfo" + os.sep + self.image_file[no][0:len(self.image_file[no])-4] + ".nfo")
			# Moving thumb
			file_util.move_file(self.bgpath + os.sep + "collections" + os.sep + self.select_value + os.sep + "thumbs" + os.sep + self.image_file[no], self.bgpath + os.sep + "collections" + os.sep + target_name + os.sep + "thumbs", verbose=1, dry_run=0)
			s = self.bgpath + os.sep + "all" + os.sep + self.image_file[no]
			t = self.bgpath + os.sep + "collections" + os.sep + target_name + os.sep
			
			# Creating new link
			if sys.platform.startswith("win"):
                                link = open(t + name + ".jpg", "w")
                                link.write(s)
                                link.close()
			else:
				os.system("ln -s -v" + " " + '"' + s + '"' + " " + '"' + t + '"')
				os.remove(self.bgpath + os.sep + "collections" + os.sep + self.select_value + os.sep + self.image_file[no])
			# Changing selection
			self.load_collection()
	
	# Right click menu of the photos
	def button_event(self, widget, event):
		if event.button == 3:
			popup = gtk.Menu()
			item = gtk.ImageMenuItem(stock_id="_Remove")
			item.connect("activate", self.remove_files)
			item.show()
			popup.append(item)
			item = gtk.ImageMenuItem(stock_id="_Export")
			item.connect("activate", self.export_pix)
			item.show()
			popup.append(item)
			popup.popup(None,None,None,event.button,event.time)
			self.numsel = -1
			for a in self.button:
				self.numsel = self.numsel + 1
				if a == widget:
					break
			self.selected_img = self.image_file[self.numsel]

	# Removing wanted files
	def remove_files(self, widget):
			os.remove(self.bgpath + os.sep + "all" +  os.sep + self.image_file[self.numsel])            
                        os.remove(self.bgpath + os.sep + "collections" + os.sep + self.select_value + os.sep + self.image_file[self.numsel])
			os.remove(self.bgpath + os.sep + "collections" + os.sep + self.select_value + os.sep + "thumbs" + os.sep + self.image_file[self.numsel])
			os.remove(self.bgpath + os.sep + "collections" + os.sep + self.select_value + os.sep + "nfo" + os.sep + self.image_file[self.numsel][0:len(self.image_file[self.numsel])-4] + ".nfo")
			self.load_collection()

	# Right click menu of the collections
	def button_event2(self, widget, event):
		if event.button == 3:
			popup = gtk.Menu()
			item = gtk.ImageMenuItem(stock_id="_Add")
			item.connect("activate", self.add_group_dialog)
			item.show()
			popup.append(item)
			item = gtk.ImageMenuItem(stock_id="_Remove")
			item.connect("activate", self.remove_group_dialog)
			item.show()
			popup.append(item)
			item = gtk.ImageMenuItem(stock_id="_Rename")
			item.connect("activate", self.rename_catagories)
			item.show()
			popup.append(item)
			popup.popup(None,None,None,event.button,event.time)

	# Functions to rename the category
	def rename_catagories(self, widget):
		windowname = "dialog_rename"
		self.rename_dialog = gtk.glade.XML(self.gladefile, windowname)
		actions = {"on_okbutton4_clicked": self.rename,
			"on_cancelbutton4_clicked": self.kill_rename_cat}
		self.rename_dialog.signal_autoconnect(actions)

	def rename(self, widget):
		new_name = self.rename_dialog.get_widget("entry8").get_text()
		os.rename(self.bgpath + os.sep + "collections" + os.sep + self.select_value, self.bgpath + os.sep + "collections" + os.sep + new_name)
		self.refresh_categories()
		self.rename_dialog.get_widget("dialog_rename").destroy()
		

	def kill_rename_cat(self, widget):
		self.rename_dialog.get_widget("dialog_rename").destroy()


	# Functions to remove and add a the category
	def add_group(self, widget):
		group = self.dialog_add.get_widget("entry1").get_text()
		self.bgpath + os.sep + "collection" + os.sep + group
		os.mkdir(self.bgpath + os.sep + "collections" + os.sep + group)
		os.mkdir(self.bgpath + os.sep + "collections" + os.sep + group + os.sep + "nfo")
		os.mkdir(self.bgpath + os.sep + "collections" + os.sep + group + os.sep + "thumbs")
		if self.albums == []:
                                self.run_check()
		iter = self.treemodel.append(None)
		self.treemodel.set(iter, 0, group)
		self.albums = os.listdir(self.bgpath + os.sep + "collections")
		self.refresh_categories()
		self.dialog_add.get_widget("dialog_add_group").destroy()

	def add_group_dialog(self, widget):
		windowname = "dialog_add_group"
		self.dialog_add = gtk.glade.XML(self.gladefile,windowname)
		actions = {"on_okbutton1_clicked": self.add_group,
			"on_cancelbutton1_clicked": self.kill_group_dialog}
		self.dialog_add.signal_autoconnect(actions)
	
	def kill_group_dialog(self, widget):
		self.dialog_add.get_widget("dialog_add_group").destroy()

	def remove_group_dialog(self, widget):
		windowname = "dialog_confirm"
		self.dialog_confirm = gtk.glade.XML(self.gladefile, windowname)
		actions = {"on_okbutton2_clicked": self.remove_group,
			"on_cancelbutton2_clicked": self.kill_confirm_dialog}
		self.dialog_confirm.signal_autoconnect(actions)
		

	def remove_group(self, widget):
		try:
			os.rmdir(self.bgpath + os.sep + "collections" + os.sep + self.select_value + os.sep + "thumbs")
			os.rmdir(self.bgpath + os.sep + "collections" + os.sep + self.select_value + os.sep + "nfo")
		except:
			pass
		dir_util.remove_tree(self.bgpath + os.sep + "collections" + os.sep + self.select_value)
		model, iter = self.selection.get_selected()
		self.treemodel.remove(iter)
		self.albums = os.listdir(self.bgpath + os.sep + "collections")
		self.refresh_categories()
		self.dialog_confirm.get_widget("dialog_confirm").destroy()
	
	def kill_confirm_dialog(self, widget):
		self.dialog_confirm.get_widget("dialog_confirm").destroy()

	# Functions for the get_file dialog
	# Just the window
	def get_file(self, widget):
		# setting dir to home for fileselectiondialog
		self.current_wdir = os.getcwd()
		os.chdir(self.conf_path)
		windowname = "fileselection1"
		self.fileselection = gtk.glade.XML(self.gladefile, windowname)
		actions = {"on_ok_button1_clicked": self.getfilename,
			"on_cancel_button1_clicked": self.kill_fileselection}
		self.fileselection.signal_autoconnect(actions)
	
	# Killing the window
	def kill_fileselection(self, widget):
		self.fileselection.get_widget("fileselection1").destroy()
		os.chdir(self.current_wdir)

	# The function to get the filename
	def getfilename(self, widget):
		filename = self.fileselection.get_widget("fileselection1").get_filename()
		# Stuff for the import dialog
		if self.which_file == 1:
			tab_no = self.dialog_import.get_widget("notebook1").get_current_page()
			if tab_no == 2:
				cnum = -1
				snum = -1
				for c in filename:
					cnum = cnum + 1
					if c == os.sep:
						snum = cnum
						self.orig_filename = filename[snum +1:]
				self.dialog_import.get_widget("entry3").set_text(filename)
				self.dialog_import.get_widget("entry5").set_text(filename[snum +1:len(filename)-4])
			if tab_no == 0:
                                if filename[len(filename)-4:len(filename)-1] == ".wb":
					self.dialog_import.get_widget("entry2").set_text(filename)
			if tab_no == 1:
				if filename[len(filename)-4:len(filename)] == ".wse":
					self.dialog_import.get_widget("entry10").set_text(filename)
		# Stuff for the export dialog
		if self.which_file == 2:
			if os.path.isdir(filename) == True:
				self.dialog_export.get_widget("entry9").set_text(filename)
			elif os.path.isfile(filename) == True:
				cnum = -1
				snum = -1
				for c in filename:
					cnum = cnum + 1
					if c == os.sep:
						snum = cnum
						self.dialog_export.get_widget("entry9").set_text(filename[0:snum +1])
		# Get file for the setting dialog
		if self.which_file == 3:
			if os.path.isdir(filename) == True:
				self.dialog_settings.get_widget("entry11").set_text(filename)
			elif os.path.isfile(filename) == True:
				cnum = -1
				snum = -1
				for c in filename:
					cnum = cnum + 1
					if c == os.sep:
						snum = cnum
						self.dialog_settings.get_widget("entry11").set_text(filename[0:snum +1])
		self.fileselection.get_widget("fileselection1").destroy()

	# The about dialog
	def about_dialog(self, widget):
		windowname = "dialog_about"
		self.dialog_about = gtk.glade.XML(self.gladefile, windowname)
		actions = {"on_closebutton1_clicked": self.kill_about_dialog}
		self.dialog_about.signal_autoconnect(actions)
		license = open("GPL.txt")
		text = gtk.TextBuffer()
		text.set_text(license.read())
		self.dialog_about.get_widget("textview1").set_buffer(text)
	
	def kill_about_dialog(self, widget):
		self.dialog_about.get_widget("dialog_about").destroy()

	# Functions for importing jpegs, wbx and wse
	def import_pix(self, widget):
		windowname = "dialog_import"
		self.dialog_import = gtk.glade.XML(self.gladefile, windowname)
		self.which_file = 1
		actions = {"on_okbutton3_clicked": self.import_it,
			"on_cancelbutton3_clicked": self.kill_import_dialog,
			"on_button_file2_clicked": self.get_file,
			"on_button_file_clicked": self.get_file}
		self.dialog_import.signal_autoconnect(actions)
		
		# Getting collections in the combo list
		self.dialog_import.get_widget("combo1").set_popdown_strings(self.albums)

	def import_it(self, widget):
		tab_no = self.dialog_import.get_widget("notebook1").get_current_page()
		# Single jpg
		if tab_no == 2 and not self.dialog_import.get_widget("entry3").get_text() == "":
			title = self.dialog_import.get_widget("entry5").get_text()
			author = self.dialog_import.get_widget("entry6").get_text()
			collection = self.dialog_import.get_widget("combo-entry1").get_text()
			category = self.dialog_import.get_widget("entry7").get_text()
			wnum = "n/a"
			filedir = self.dialog_import.get_widget("entry3").get_text()
			# Creating new collections if not exists
			dir_util.mkpath(self.bgpath + os.sep + "collections" + os.sep + collection)
			dir_util.mkpath(self.bgpath + os.sep + "collections" + os.sep + collection + os.sep + "nfo")
			dir_util.mkpath(self.bgpath + os.sep + "collections" + os.sep + collection + os.sep + "thumbs")
			
			# Creating New nfo file
			info_f_target = open(self.bgpath + os.sep + "collections" + os.sep + collection + os.sep + "nfo" + os.sep + title + ".nfo", "w")
			# Writing new nfo file
			info_f_target.write("TITLE:" + title + "\n"
					"CREDIT:" + author + "\n"
					"COLLECTION:" + collection + "\n"
					"CATAGORY:" + category + "\n"
					"ALBUM:" + collection + "\n"
					"WNUM:" + wnum + "\n"
					"FILE_SIZE:" + "NORMAL" + "\n"
					"FILE_TYPE:" + "WebSun_imported" + "\n")
			info_f_target.close()
			# Copying and renaming the image 
			file_util.copy_file(filedir, self.bgpath + os.sep + "all")
			os.rename(self.bgpath + os.sep + "all" +  os.sep + self.orig_filename, self.bgpath + os.sep + "all" +  os.sep + title + ".jpg")
			# Making symlink or fake jpeg in win32
			s = self.bgpath + os.sep + "all" + os.sep + title + ".jpg" 
			t = self.bgpath + os.sep + "collections" + os.sep + collection + os.sep
			if sys.platform.startswith("win"):
                            link = open(t + title + ".jpg", "w")
                            link.write(s)
                            link.close()
                        else:
                            os.system("ln -s -v" + " " + '"' + s + '"' + " " + '"' + t + '"')
			# Making thumbnail
			s = self.bgpath + os.sep + "all" + os.sep + title + ".jpg"
                        t = self.bgpath + os.sep + "collections" + os.sep + collection + os.sep + "thumbs" + os.sep + title + ".jpg"
                        os.system('%s "%s" -resize 73x55 "%s"' % (self.convert, s, t))
			if collection == self.select_value:
				self.get_thumbs(self.path)
			
			if not collection in self.albums:
				self.albums = os.listdir(self.bgpath + os.sep + "collections")
                        if self.albums == []:
                                self.run_check()
			self.refresh_categories()
		
		# WebShots format
		if tab_no == 0 and not self.dialog_import.get_widget("entry2").get_text() == "":
			old_dir = os.getcwd()
			if os.path.isdir(self.bgpath + os.sep + "tmp"):
                            dir_util.remove_tree(self.bgpath + os.sep + "tmp")
                        dir_util.mkpath(self.bgpath + os.sep + "tmp")
			os.chdir(self.bgpath + os.sep + "tmp")
			os.system('webdec "%s" meta' % (self.dialog_import.get_widget("entry2").get_text()))
    			for n in os.listdir(os.curdir):
				name = n[0:len(n)-4]
			config = open(name + ".nfo", "r")
			for l in config.readlines():
				if l.startswith("COLLECTION:"):
					collection = l[l.find(":")+1:].strip()	
			config.close()
		    
			if os.path.isfile(self.bgpath + os.sep + "collections" + os.sep + collection + os.sep + "nfo" + os.sep + name + ".nfo") == False and os.path.isfile(self.bgpath + os.sep + "all" + os.sep + name + ".jpg") == False and os.path.isfile(self.bgpath + os.sep + "collections" + os.sep + collection + os.sep + "thumbs" + os.sep + name + ".jpg") == False:	
			# Try to make the required dirs in case they dont exist.
                                dir_util.mkpath(self.bgpath + os.sep + "collections" + os.sep + collection)
                         	dir_util.mkpath(self.bgpath + os.sep + "collections" + os.sep + collection + os.sep + "nfo")
				dir_util.mkpath(self.bgpath + os.sep + "collections" + os.sep + collection + os.sep + "thumbs")
				# moving files
				file_util.move_file(name + ".nfo", self.bgpath + os.sep + "collections" + os.sep + collection + os.sep + "nfo")
				file_util.move_file(name + ".jpg", self.bgpath + os.sep + "all")
				s = self.bgpath + os.sep + "all" + os.sep + name + ".jpg" 
				t = self.bgpath + os.sep + "collections" + os.sep + collection + os.sep
				if sys.platform.startswith("win"):
                                    link = open(t + name + ".jpg", "w")
                                    link.write(s)
                                    link.close()
                                else:
                                    os.system("ln -s -v" + " " + '"' + s + '"' + " " + '"' + t + '"')
				os.chdir(old_dir)

			# Cleaning up
			dir_util.remove_tree(self.bgpath + os.sep + "tmp")
			if self.albums == []:
                                self.run_check()
			self.refresh_categories()	

		# WSE format
		if tab_no == 1 and not self.dialog_import.get_widget("entry10").get_text() == "":
			wse = zipfile.ZipFile(self.dialog_import.get_widget("entry10").get_text(), "r")
			content = wse.namelist()
			for a in content:
				configfile = wse.read(a)
				for l in StringIO.StringIO(configfile).readlines():
					if l.startswith("TITLE:"):
						name = l[l.find(":")+1:].strip()
					elif l.startswith("COLLECTION:"):
						collection = l[l.find(":")+1:].strip()
			if os.path.isfile(self.bgpath + os.sep + "collections" + os.sep + collection + os.sep + "nfo" + os.sep + name + ".nfo") == False and os.path.isfile(self.bgpath + os.sep + "all" + os.sep + name + ".jpg") == False and os.path.isfile(self.bgpath + os.sep + "collections" + os.sep + collection + os.sep + "thumbs" + os.sep + name + ".jpg") == False:
				try: 
					os.mkdir(self.bgpath + os.sep + "collections" + os.sep + collection)
				except:
					pass
				for c in content:
					if ".nfo" in c:
						try:
							os.mkdir(self.bgpath + os.sep + "collections" + os.sep + collection + os.sep + "nfo")
						except:
							pass
						extr = wse.read(c)
						extr_f = open(self.bgpath + os.sep + "collections" + os.sep + collection + os.sep + "nfo" + os.sep + name + ".nfo", "wb")
						extr_f.write(extr)
						extr_f.flush()
						extr_f.close()
					elif "thumbs" in c:
						dir_util.mkpath(self.bgpath + os.sep + "collections" + os.sep + collection + os.sep +  "thumbs")		
						extr = wse.read(c)
						extr_f = open(self.bgpath + os.sep + "collections" + os.sep + collection + os.sep + "thumbs" + os.sep + name + ".jpg", "wb")
						extr_f.write(extr)
						extr_f.flush()
						extr_f.close()
					else:	
						extr = wse.read(c)
						extr_f = open(self.bgpath + os.sep + "all" + os.sep + name + ".jpg", "wb")
						extr_f.write(extr)
						extr_f.flush()
						extr_f.close()
						s = self.bgpath + os.sep + "all" + os.sep + name + ".jpg" 
						t = self.bgpath + os.sep + "collections" + os.sep + collection + os.sep
                                                if sys.platform.startswith("win"):
                                                    link = open(t + name + ".jpg", "w")
                                                    link.write(s)
                                                    link.close()
                                                else:
							os.system("ln -s -v" + " " + '"' + s + '"' + " " + '"' + t + '"')
						  
			wse.close()
			if self.albums == []:
                                self.run_check()
			self.refresh_categories()	
		self.dialog_import.get_widget("dialog_import").destroy()

	# Functions for exporting to wse
	def export_pix(self, widget):
		windowname = "dialog_export"
		self.dialog_export = gtk.glade.XML(self.gladefile, windowname)
		self.which_file = 2
		actions = {"on_okbutton5_clicked": self.export_it,
			"on_cancelbutton5_clicked": self.kill_export_dialog,
			"on_button_file_clicked": self.get_file}
		self.dialog_export.signal_autoconnect(actions)

	def kill_export_dialog(self, widget):
		self.dialog_export.get_widget("dialog_export").destroy()	
	
	def export_it(self, widget):
		current_dir = os.getcwd()
		os.chdir(self.dialog_export.get_widget("entry9").get_text())
		wse = zipfile.ZipFile(self.selected_img[0:len(self.selected_img)-4] + ".wse", "w")
		os.chdir(self.bgpath + os.sep + "all")
		wse.write(self.selected_img)
		os.chdir(self.bgpath + os.sep + "collections" + os.sep + self.select_value)
		wse.write("nfo" + os.sep + self.selected_img[0:len(self.selected_img)-4] + ".nfo")
		wse.write("thumbs" + os.sep + self.selected_img)
		wse.close()
		os.chdir(current_dir)
		self.dialog_export.get_widget("dialog_export").destroy()	

	def kill_import_dialog(self, widget):
		self.dialog_import.get_widget("dialog_import").destroy()	
	
	
# Starting class
app = websun()
gtk.mainloop()
